#define  STRICT
#include <windows.h>
#include <vfw.h>
#include "resource.h"

#pragma comment(lib,"vfw32.lib")

#define MYWNDTITLE	"MciWndPlayer"
#define MYWNDCLASS	"CLASS_MciWndPlayer"

HWND	g_hWnd  = NULL;
HWND	g_hMCI  = NULL;
HMENU	g_hMenu = NULL;

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Resize();
void Open_FileDlg();
void Save_FileDlg();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	g_hMenu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_MENU1));
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN,
				CW_USEDEFAULT, CW_USEDEFAULT, 150, 50,
				NULL,
				g_hMenu,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		g_hWnd = hWnd;
		g_hMCI = MCIWndCreate(hWnd,
						GetModuleHandle(NULL),
						MCIWNDF_NOTIFYALL |
						MCIWNDF_RECORD |
						WS_CHILD |
						WS_VISIBLE,
						NULL);
		if (g_hMCI == NULL)
			return 0;
		Resize();
		MCIWndNew(g_hMCI, "waveaudio");		// ^ݒisystem.ini  [mci] QƁj
		MCIWndSetInactiveTimer(g_hMCI, 100);// XC_[̈ړԊu
		break;
	
	case WM_SIZE:
		MoveWindow(g_hMCI, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
		break;
	
	case MCIWNDM_NOTIFYSIZE:	// qEBhẼTCYςƂ
		Resize();
		break;
	
	case WM_MENUSELECT:
		long size;
		size = MCIWndGetLength(g_hMCI);		// ^ẽTCYiPʂ̓^CtH[}bgɂĈقȂj
		if(MCIWndCanSave(g_hMCI) && size > 0)
			EnableMenuItem(g_hMenu, IDM_SAVE, MF_BYCOMMAND | MF_ENABLED);
		else
			EnableMenuItem(g_hMenu, IDM_SAVE, MF_BYCOMMAND | MF_GRAYED);
		break;
	
	case WM_COMMAND:
		switch (wParam)
		{
		case IDM_OPEN:		// t@CJčĐ
			Open_FileDlg();
			MCIWndPlay(g_hMCI);
			break;
		case IDM_RECORD:	// }CNŘ^
			MCIWndStop(g_hMCI);
			MCIWndClose(g_hMCI);
			MCIWndNew(g_hMCI, "waveaudio");
			break;
		case IDM_SAVE:		// ^et@Cɕۑ
			Save_FileDlg();
			break;
		case IDM_REVERSE:	// tĐ
			MCIWndPlayReverse(g_hMCI);
			break;
		case IDM_EXIT:		// I
			SendMessage(hWnd,WM_CLOSE,0,0);
			break;
		}
		break;
	
	case WM_CLOSE:
		MCIWndStop(g_hMCI);
		MCIWndClose(g_hMCI);
		MCIWndDestroy(g_hMCI);
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		break;
	
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// ProcWin

void Resize()
{
	int	frame_wdh,frame_hgt,title_hgt,menu_hgt;
	RECT rc,rc_m;
	frame_wdh  = GetSystemMetrics(SM_CXFRAME);
	frame_hgt  = GetSystemMetrics(SM_CYFRAME);
	title_hgt  = GetSystemMetrics(SM_CYCAPTION);
	menu_hgt   = GetSystemMetrics(SM_CYMENU);
	GetWindowRect(g_hWnd, &rc);
	GetWindowRect(g_hMCI, &rc_m);
	MoveWindow(g_hWnd, rc.left, rc.top, rc_m.right-rc_m.left+frame_wdh*2,
			rc_m.bottom-rc_m.top+title_hgt+menu_hgt+frame_hgt*2, TRUE);
}// Resize

void Open_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = g_hWnd;
	ofn.Flags = OFN_PATHMUSTEXIST | 
				OFN_FILEMUSTEXIST | 
				OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter =	"fBAt@C\0" "*.avi;*mpg;*.mpeg;*.mov;*.wmv;*.wav;*.wma;*.au;*.aif;*.mid;*.mp3;*.midi;*.cda;\0" 
						"t@C (*.avi; *.mpg; *.mpeg; *.mov; *.wmv)\0" "*.avi;*mpg;*.mpeg;*.mov;*.wmv\0" 
						"yt@C (*.wav; *.wma; *.au; *.aif; *.mid; *.mp3; *.midi)\0" "*.wav;*.wma;*.au;*.aif;*.mid;*.mp3;*.midi\0" 
						"CD (*.cda)\0" "*.cda\0"
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileNamePreview(&ofn)){
		MCIWndClose(g_hMCI);
		MCIWndOpen(g_hMCI, fn, 0);
	}
}// Open_FileDlg

void Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = g_hWnd;
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter = "̧ (*.wav)\0*.wav\0" "ׂẴt@C (*.*)\0*.*\0";
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		MCIWndSave(g_hMCI, fn);
		MCIWndClose(g_hMCI);
	}
}// Save_FileDlg
